diff -rupN gcc-4.7-20120605/gcc/config/mep/mep.opt gcc-4.7-20120605-hjl-x32/gcc/config/mep/mep.opt
--- gcc-4.7-20120605/gcc/config/mep/mep.opt	2011-03-22 23:49:06.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/config/mep/mep.opt	2012-06-05 15:38:08.000000000 +0200
@@ -55,7 +55,7 @@ Target Mask(COP)
 Enable MeP Coprocessor
 
 mcop32
-Target Mask(COP) MaskExists RejectNegative
+Target Mask(COP) RejectNegative
 Enable MeP Coprocessor with 32-bit registers
 
 mcop64
diff -rupN gcc-4.7-20120605/gcc/config/pa/pa-hpux.opt gcc-4.7-20120605-hjl-x32/gcc/config/pa/pa-hpux.opt
--- gcc-4.7-20120605/gcc/config/pa/pa-hpux.opt	2011-05-05 17:49:28.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config/pa/pa-hpux.opt	2012-06-05 15:38:08.000000000 +0200
@@ -23,7 +23,7 @@ Variable
 int flag_pa_unix = TARGET_HPUX_11_31 ? 2003 : TARGET_HPUX_11_11 ? 1998 : TARGET_HPUX_10_10 ? 1995 : 1993
 
 msio
-Target RejectNegative Mask(SIO) MaskExists
+Target RejectNegative Mask(SIO)
 Generate cpp defines for server IO
 
 munix=93
diff -rupN gcc-4.7-20120605/gcc/config/pa/pa64-hpux.opt gcc-4.7-20120605-hjl-x32/gcc/config/pa/pa64-hpux.opt
--- gcc-4.7-20120605/gcc/config/pa/pa64-hpux.opt	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config/pa/pa64-hpux.opt	2012-06-05 15:38:08.000000000 +0200
@@ -19,7 +19,7 @@
 ; <http://www.gnu.org/licenses/>.
 
 mgnu-ld
-Target RejectNegative Mask(GNU_LD) MaskExists
+Target RejectNegative Mask(GNU_LD)
 Assume code will be linked by GNU ld
 
 mhp-ld
diff -rupN gcc-4.7-20120605/gcc/config/picochip/picochip.opt gcc-4.7-20120605-hjl-x32/gcc/config/picochip/picochip.opt
--- gcc-4.7-20120605/gcc/config/picochip/picochip.opt	2008-12-16 17:30:26.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/config/picochip/picochip.opt	2012-06-05 15:38:08.000000000 +0200
@@ -43,4 +43,4 @@ Target Mask(INEFFICIENT_WARNINGS)
 Generate warnings when inefficient code is known to be generated.
 
 minefficient
-Target Mask(INEFFICIENT_WARNINGS) MaskExists Undocumented
+Target Mask(INEFFICIENT_WARNINGS) Undocumented
diff -rupN gcc-4.7-20120605/gcc/config/rs6000/sysv4.opt gcc-4.7-20120605-hjl-x32/gcc/config/rs6000/sysv4.opt
--- gcc-4.7-20120605/gcc/config/rs6000/sysv4.opt	2011-05-05 16:59:55.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config/rs6000/sysv4.opt	2012-06-05 15:38:08.000000000 +0200
@@ -66,7 +66,7 @@ Target Report RejectNegative Mask(LITTLE
 Produce little endian code
 
 mlittle
-Target Report RejectNegative Mask(LITTLE_ENDIAN) MaskExists
+Target Report RejectNegative Mask(LITTLE_ENDIAN)
 Produce little endian code
 
 mbig-endian
diff -rupN gcc-4.7-20120605/gcc/config/sh/sh.opt gcc-4.7-20120605-hjl-x32/gcc/config/sh/sh.opt
--- gcc-4.7-20120605/gcc/config/sh/sh.opt	2011-12-05 00:05:23.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/config/sh/sh.opt	2012-06-05 15:38:08.000000000 +0200
@@ -316,7 +316,7 @@ Target Report RejectNegative Mask(RELAX)
 Shorten address references during linking
 
 mrenesas
-Target Mask(HITACHI) MaskExists
+Target Mask(HITACHI)
 Follow Renesas (formerly Hitachi) / SuperH calling conventions
 
 msoft-atomic
diff -rupN gcc-4.7-20120605/gcc/config/sparc/long-double-switch.opt gcc-4.7-20120605-hjl-x32/gcc/config/sparc/long-double-switch.opt
--- gcc-4.7-20120605/gcc/config/sparc/long-double-switch.opt	2007-08-02 12:49:31.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config/sparc/long-double-switch.opt	2012-06-05 15:38:08.000000000 +0200
@@ -19,7 +19,7 @@
 ; <http://www.gnu.org/licenses/>.
 
 mlong-double-128
-Target Report RejectNegative Mask(LONG_DOUBLE_128) MaskExists
+Target Report RejectNegative Mask(LONG_DOUBLE_128)
 Use 128-bit long double
 
 mlong-double-64
diff -rupN gcc-4.7-20120605/gcc/config/sparc/sparc.opt gcc-4.7-20120605-hjl-x32/gcc/config/sparc/sparc.opt
--- gcc-4.7-20120605/gcc/config/sparc/sparc.opt	2011-11-30 17:10:24.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/config/sparc/sparc.opt	2012-06-05 15:38:08.000000000 +0200
@@ -30,7 +30,7 @@ Target Report Mask(FPU)
 Use hardware FP
 
 mhard-float
-Target RejectNegative Mask(FPU) MaskExists
+Target RejectNegative Mask(FPU)
 Use hardware FP
 
 msoft-float
diff -rupN gcc-4.7-20120605/gcc/config/v850/v850.opt gcc-4.7-20120605-hjl-x32/gcc/config/v850/v850.opt
--- gcc-4.7-20120605/gcc/config/v850/v850.opt	2011-03-22 23:48:11.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/config/v850/v850.opt	2012-06-05 15:38:08.000000000 +0200
@@ -102,7 +102,7 @@ Target RejectNegative Mask(V850E1)
 Compile for the v850e1 processor
 
 mv850es
-Target RejectNegative Mask(V850E1) MaskExists
+Target RejectNegative Mask(V850E1)
 Compile for the v850es variant of the v850e1
 
 mv850e2
diff -rupN gcc-4.7-20120605/gcc/config/vax/vax.opt gcc-4.7-20120605-hjl-x32/gcc/config/vax/vax.opt
--- gcc-4.7-20120605/gcc/config/vax/vax.opt	2009-04-01 19:00:00.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config/vax/vax.opt	2012-06-05 15:38:08.000000000 +0200
@@ -31,7 +31,7 @@ Target RejectNegative Mask(G_FLOAT)
 Generate GFLOAT double precision code
 
 mg-float
-Target RejectNegative Mask(G_FLOAT) MaskExists
+Target RejectNegative Mask(G_FLOAT)
 Generate GFLOAT double precision code
 
 mgnu
diff -rupN gcc-4.7-20120605/gcc/config.gcc gcc-4.7-20120605-hjl-x32/gcc/config.gcc
--- gcc-4.7-20120605/gcc/config.gcc	2012-06-10 17:47:23.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/config.gcc	2012-06-05 15:38:08.000000000 +0200
@@ -486,6 +486,10 @@ fi
 
 case ${target} in
 i[34567]86-*-*)
+	if test "x$with_abi" != x; then
+		echo "This target does not support --with-abi."
+		exit 1
+	fi
 	if test "x$enable_cld" = xyes; then
 		tm_defines="${tm_defines} USE_IX86_CLD=1"
 	fi
@@ -495,7 +499,24 @@ i[34567]86-*-*)
 	tm_file="vxworks-dummy.h ${tm_file}"
 	;;
 x86_64-*-*)
-	tm_file="i386/biarch64.h ${tm_file}"
+	case ${with_abi} in
+	"")
+		if test "x$with_multilib_list" = xmx32; then
+			tm_file="i386/biarchx32.h ${tm_file}"
+		else
+			tm_file="i386/biarch64.h ${tm_file}"
+		fi
+		;;
+	64 | m64)
+		tm_file="i386/biarch64.h ${tm_file}"
+		;;
+	x32 | mx32)
+		tm_file="i386/biarchx32.h ${tm_file}"
+		;;
+	*)
+		echo "Unknown ABI used in --with-abi=$with_abi"
+		exit 1
+	esac
 	if test "x$enable_cld" = xyes; then
 		tm_defines="${tm_defines} USE_IX86_CLD=1"
 	fi
@@ -1306,7 +1327,14 @@ x86_64-*-linux* | x86_64-*-kfreebsd*-gnu
 	tmake_file="${tmake_file} i386/t-linux64"
 	x86_multilibs="${with_multilib_list}"
 	if test "$x86_multilibs" = "default"; then
-		x86_multilibs="m64,m32"
+		case ${with_abi} in
+		x32 | mx32)
+			x86_multilibs="mx32"
+			;;
+		*)
+			x86_multilibs="m64,m32"
+			;;
+		esac
 	fi
 	x86_multilibs=`echo $x86_multilibs | sed -e 's/,/ /g'`
 	for x86_multilib in ${x86_multilibs}; do
@@ -3203,7 +3231,7 @@ case "${target}" in
 		;;
 
 	i[34567]86-*-* | x86_64-*-*)
-		supported_defaults="arch arch_32 arch_64 cpu cpu_32 cpu_64 tune tune_32 tune_64"
+		supported_defaults="abi arch arch_32 arch_64 cpu cpu_32 cpu_64 tune tune_32 tune_64"
 		for which in arch arch_32 arch_64 cpu cpu_32 cpu_64 tune tune_32 tune_64; do
 			eval "val=\$with_$which"
 			case ${val} in
diff -rupN gcc-4.7-20120605/gcc/dwarf2out.c gcc-4.7-20120605-hjl-x32/gcc/dwarf2out.c
--- gcc-4.7-20120605/gcc/dwarf2out.c	2012-06-10 17:47:31.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/dwarf2out.c	2012-06-05 15:38:08.000000000 +0200
@@ -10178,7 +10178,9 @@ dbx_reg_number (const_rtx rtl)
     }
 #endif
 
-  return DBX_REGISTER_NUMBER (regno);
+  regno = DBX_REGISTER_NUMBER (regno);
+  gcc_assert (regno != INVALID_REGNUM);
+  return regno;
 }
 
 /* Optionally add a DW_OP_piece term to a location description expression.
diff -rupN gcc-4.7-20120605/gcc/emit-rtl.c gcc-4.7-20120605-hjl-x32/gcc/emit-rtl.c
--- gcc-4.7-20120605/gcc/emit-rtl.c	2012-02-22 11:37:03.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/emit-rtl.c	2012-06-05 15:38:08.000000000 +0200
@@ -964,6 +964,22 @@ void
 set_reg_attrs_from_value (rtx reg, rtx x)
 {
   int offset;
+  bool can_be_reg_pointer = true;
+
+  /* Don't call mark_reg_pointer for incompatible pointer sign
+     extension.  */
+  while (GET_CODE (x) == SIGN_EXTEND
+	 || GET_CODE (x) == ZERO_EXTEND
+	 || GET_CODE (x) == TRUNCATE
+	 || (GET_CODE (x) == SUBREG && subreg_lowpart_p (x)))
+    {
+#if defined(POINTERS_EXTEND_UNSIGNED) && !defined(HAVE_ptr_extend)
+      if ((GET_CODE (x) == SIGN_EXTEND && POINTERS_EXTEND_UNSIGNED)
+	  || (GET_CODE (x) != SIGN_EXTEND && ! POINTERS_EXTEND_UNSIGNED))
+	can_be_reg_pointer = false;
+#endif
+      x = XEXP (x, 0);
+    }
 
   /* Hard registers can be reused for multiple purposes within the same
      function, so setting REG_ATTRS, REG_POINTER and REG_POINTER_ALIGN
@@ -977,14 +993,14 @@ set_reg_attrs_from_value (rtx reg, rtx x
       if (MEM_OFFSET_KNOWN_P (x))
 	REG_ATTRS (reg) = get_reg_attrs (MEM_EXPR (x),
 					 MEM_OFFSET (x) + offset);
-      if (MEM_POINTER (x))
+      if (can_be_reg_pointer && MEM_POINTER (x))
 	mark_reg_pointer (reg, 0);
     }
   else if (REG_P (x))
     {
       if (REG_ATTRS (x))
 	update_reg_offset (reg, x, offset);
-      if (REG_POINTER (x))
+      if (can_be_reg_pointer && REG_POINTER (x))
 	mark_reg_pointer (reg, REGNO_POINTER_ALIGN (REGNO (x)));
     }
 }
diff -rupN gcc-4.7-20120605/gcc/opth-gen.awk gcc-4.7-20120605-hjl-x32/gcc/opth-gen.awk
--- gcc-4.7-20120605/gcc/opth-gen.awk	2011-08-19 12:16:02.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/gcc/opth-gen.awk	2012-06-05 15:38:08.000000000 +0200
@@ -298,16 +298,25 @@ print "";
 
 for (i = 0; i < n_opts; i++) {
 	name = opt_args("Mask", flags[i])
-	vname = var_name(flags[i])
-	mask = "MASK_"
-	mask_1 = "1"
-	if (vname != "") {
-		mask = "OPTION_MASK_"
-		if (host_wide_int[vname] == "yes")
-			mask_1 = "HOST_WIDE_INT_1"
+	if (name == "") {
+		opt = opt_args("InverseMask", flags[i])
+		if (opt ~ ",")
+			name = nth_arg(0, opt)
+		else
+			name = opt
 	}
-	if (name != "" && !flag_set_p("MaskExists", flags[i]))
+	if (name != "" && mask_bits[name] == 0) {
+		mask_bits[name] = 1
+		vname = var_name(flags[i])
+		mask = "MASK_"
+		mask_1 = "1"
+		if (vname != "") {
+			mask = "OPTION_MASK_"
+			if (host_wide_int[vname] == "yes")
+				mask_1 = "HOST_WIDE_INT_1"
+		}
 		print "#define " mask name " (" mask_1 " << " masknum[vname]++ ")"
+	}
 }
 for (i = 0; i < n_extra_masks; i++) {
 	print "#define MASK_" extra_masks[i] " (1 << " masknum[""]++ ")"
@@ -330,17 +339,26 @@ print ""
 
 for (i = 0; i < n_opts; i++) {
 	name = opt_args("Mask", flags[i])
-	vname = var_name(flags[i])
-	macro = "OPTION_"
-	mask = "OPTION_MASK_"
-	if (vname == "") {
-		vname = "target_flags"
-		macro = "TARGET_"
-		mask = "MASK_"
+	if (name == "") {
+		opt = opt_args("InverseMask", flags[i])
+		if (opt ~ ",")
+			name = nth_arg(0, opt)
+		else
+			name = opt
 	}
-	if (name != "" && !flag_set_p("MaskExists", flags[i]))
+	if (name != "" && mask_macros[name] == 0) {
+		mask_macros[name] = 1
+		vname = var_name(flags[i])
+		macro = "OPTION_"
+		mask = "OPTION_MASK_"
+		if (vname == "") {
+			vname = "target_flags"
+			macro = "TARGET_"
+			mask = "MASK_"
+		}
 		print "#define " macro name \
 		      " ((" vname " & " mask name ") != 0)"
+	}
 }
 for (i = 0; i < n_extra_masks; i++) {
 	print "#define TARGET_" extra_masks[i] \
diff -rupN gcc-4.7-20120605/gcc/reginfo.c gcc-4.7-20120605-hjl-x32/gcc/reginfo.c
--- gcc-4.7-20120605/gcc/reginfo.c	2012-01-31 20:11:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/reginfo.c	2012-06-05 15:38:08.000000000 +0200
@@ -1222,17 +1222,7 @@ reg_scan_mark_refs (rtx x, rtx insn)
       /* If this is setting a register from a register or from a simple
 	 conversion of a register, propagate REG_EXPR.  */
       if (REG_P (dest) && !REG_ATTRS (dest))
-	{
-	  rtx src = SET_SRC (x);
-
-	  while (GET_CODE (src) == SIGN_EXTEND
-		 || GET_CODE (src) == ZERO_EXTEND
-		 || GET_CODE (src) == TRUNCATE
-		 || (GET_CODE (src) == SUBREG && subreg_lowpart_p (src)))
-	    src = XEXP (src, 0);
-
-	  set_reg_attrs_from_value (dest, src);
-	}
+	set_reg_attrs_from_value (dest, SET_SRC (x));
 
       /* ... fall through ...  */
 
diff -rupN gcc-4.7-20120605/gcc/testsuite/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/gcc/testsuite/ChangeLog.x32
--- gcc-4.7-20120605/gcc/testsuite/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,24 @@
+2012-04-11  H.J. Lu  <hongjiu.lu@intel.com>
+
+	PR rtl-optimization/52876
+	* gcc.target/i386/pr52876.c: New.
+
+2012-04-09  Uros Bizjak  <ubizjak@gmail.com>
+
+	PR target/52883
+	* gcc.target/i386/pr52883.c: New testcase.
+
+2012-04-05  Uros Bizjak  <ubizjak@gmail.com>
+
+	PR target/52882
+	* gcc.target/i386/pr52882.c: New test.
+
+2012-03-11  Uros Bizjak  <ubizjak@gmail.com>
+
+	PR target/52530
+	* gcc.dg/torture/pr52530.c: New test.
+
+2012-03-04  H.J. Lu  <hongjiu.lu@intel.com>
+
+	PR target/52146
+	* gcc.target/i386/pr52146.c: Update final-scan to allow $-18874240.
diff -rupN gcc-4.7-20120605/gcc/testsuite/gcc.dg/torture/pr52530.c gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.dg/torture/pr52530.c
--- gcc-4.7-20120605/gcc/testsuite/gcc.dg/torture/pr52530.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.dg/torture/pr52530.c	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,30 @@
+/* { dg-do run } */
+
+extern void abort (void);
+
+struct foo
+{
+ int *f;
+ int i;
+};
+
+int baz;
+
+void __attribute__ ((noinline))
+bar (struct foo x)
+{
+ *(x.f) = x.i;
+}
+
+int
+main ()
+{
+  struct foo x = { &baz, 0xdeadbeef };
+
+  bar (x);
+
+  if (baz != 0xdeadbeef)
+    abort ();
+
+  return 0;
+}
diff -rupN gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52146.c gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52146.c
--- gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52146.c	2012-02-10 21:03:08.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52146.c	2012-06-05 15:38:08.000000000 +0200
@@ -15,4 +15,4 @@ test2 (void)
   *apic_tpr_addr = 0;
 }
 
-/* { dg-final { scan-assembler-not "-18874240" } } */
+/* { dg-final { scan-assembler-not "\[,\\t \]+-18874240" } } */
diff -rupN gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52876.c gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52876.c
--- gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52876.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52876.c	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,25 @@
+/* { dg-do run { target { x32 } } } */
+/* { dg-options "-O2 -mx32 -maddress-mode=long" } */
+
+extern void abort (void);
+
+long long li;
+
+long long 
+__attribute__ ((noinline))
+testfunc (void* addr)
+{
+  li = (long long)(int)addr;
+  li &= 0xffffffff;
+  return li;
+}
+
+int main (void)
+{
+  volatile long long rv_test;
+  rv_test = testfunc((void*)0x87651234);
+  if (rv_test != 0x87651234ULL)
+    abort ();
+
+  return 0;
+}
diff -rupN gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52882.c gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52882.c
--- gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52882.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52882.c	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,19 @@
+/* { dg-do compile } */
+/* { dg-options "-O" } */
+
+struct S1 {
+  int f0;
+  int f1;
+};
+
+int fn1 ();
+void fn2 (struct S1);
+
+void
+fn3 () {
+  struct S1 a = { 1, 0 };
+  if (fn1 ())
+    fn2 (a);
+  for (; a.f1;) {
+  }
+}
diff -rupN gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52883.c gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52883.c
--- gcc-4.7-20120605/gcc/testsuite/gcc.target/i386/pr52883.c	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/gcc/testsuite/gcc.target/i386/pr52883.c	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,25 @@
+/* { dg-do compile } */
+/* { dg-options "-O" } */
+
+int a, b, d, e, f, i, j, k, l, m;
+unsigned c;
+int g[] = { }, h[0];
+
+int
+fn1 () {
+  return 0;
+}
+
+void
+fn2 () {
+  c = 0;
+  e = 0;
+  for (;; e = 0)
+    if (f > j) {
+      k = fn1 ();
+      l = (d || k) * b;
+      m = l * a;
+      h[0] = m <= i;
+    } else
+      i = g[c];
+}
diff -rupN gcc-4.7-20120605/libffi/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libffi/ChangeLog.x32
--- gcc-4.7-20120605/libffi/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libffi/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,18 @@
+2012-05-17  H.J. Lu  <hongjiu.lu@intel.com>
+
+	Backported from mainline
+	2012-03-03  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* src/x86/ffi64.c (ffi_call): Cast the return value to unsigned
+	long.
+	(ffi_prep_closure_loc): Cast to 64bit address in trampoline.
+	(ffi_closure_unix64_inner): Cast return pointer to unsigned long
+	first.
+
+	* src/x86/ffitarget.h (FFI_SIZEOF_ARG): Defined to 8 for x32.
+	(ffi_arg): Set to unsigned long long for x32.
+	(ffi_sarg): Set to long long for x32.
+
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libffi/src/x86/ffi64.c gcc-4.7-20120605-hjl-x32/libffi/src/x86/ffi64.c
--- gcc-4.7-20120605/libffi/src/x86/ffi64.c	2011-01-03 21:52:22.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libffi/src/x86/ffi64.c	2012-06-05 15:38:08.000000000 +0200
@@ -426,7 +426,7 @@ ffi_call (ffi_cif *cif, void (*fn)(void)
   /* If the return value is passed in memory, add the pointer as the
      first integer argument.  */
   if (ret_in_memory)
-    reg_args->gpr[gprcount++] = (long) rvalue;
+    reg_args->gpr[gprcount++] = (unsigned long) rvalue;
 
   avn = cif->nargs;
   arg_types = cif->arg_types;
@@ -501,9 +501,11 @@ ffi_prep_closure_loc (ffi_closure* closu
   tramp = (volatile unsigned short *) &closure->tramp[0];
 
   tramp[0] = 0xbb49;		/* mov <code>, %r11	*/
-  *(void * volatile *) &tramp[1] = ffi_closure_unix64;
+  *((unsigned long long * volatile) &tramp[1])
+    = (unsigned long) ffi_closure_unix64;
   tramp[5] = 0xba49;		/* mov <data>, %r10	*/
-  *(void * volatile *) &tramp[6] = codeloc;
+  *((unsigned long long * volatile) &tramp[6])
+    = (unsigned long) codeloc;
 
   /* Set the carry bit iff the function uses any sse registers.
      This is clc or stc, together with the first byte of the jmp.  */
@@ -542,7 +544,7 @@ ffi_closure_unix64_inner(ffi_closure *cl
 	{
 	  /* The return value goes in memory.  Arrange for the closure
 	     return value to go directly back to the original caller.  */
-	  rvalue = (void *) reg_args->gpr[gprcount++];
+	  rvalue = (void *) (unsigned long) reg_args->gpr[gprcount++];
 	  /* We don't have to do anything in asm for the return.  */
 	  ret = FFI_TYPE_VOID;
 	}
diff -rupN gcc-4.7-20120605/libffi/src/x86/ffitarget.h gcc-4.7-20120605-hjl-x32/libffi/src/x86/ffitarget.h
--- gcc-4.7-20120605/libffi/src/x86/ffitarget.h	2012-02-08 22:35:19.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libffi/src/x86/ffitarget.h	2012-06-05 15:38:08.000000000 +0200
@@ -53,9 +53,15 @@ typedef unsigned long long     ffi_arg;
 typedef long long              ffi_sarg;
 #endif
 #else
+#if defined __x86_64__ && !defined __LP64__
+#define FFI_SIZEOF_ARG 8
+typedef unsigned long long     ffi_arg;
+typedef long long              ffi_sarg;
+#else
 typedef unsigned long          ffi_arg;
 typedef signed long            ffi_sarg;
 #endif
+#endif
 
 typedef enum ffi_abi {
   FFI_FIRST_ABI = 0,
diff -rupN gcc-4.7-20120605/libgcc/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libgcc/ChangeLog.x32
--- gcc-4.7-20120605/libgcc/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libgcc/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,4 @@
+2012-03-13  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* unwind-dw2.c (_Unwind_SetGRValue): Assert DWARF register size
+	<= saved reg size.
diff -rupN gcc-4.7-20120605/libgcc/unwind-dw2.c gcc-4.7-20120605-hjl-x32/libgcc/unwind-dw2.c
--- gcc-4.7-20120605/libgcc/unwind-dw2.c	2011-11-02 16:26:35.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libgcc/unwind-dw2.c	2012-06-05 15:38:08.000000000 +0200
@@ -294,7 +294,8 @@ _Unwind_SetGRValue (struct _Unwind_Conte
 {
   index = DWARF_REG_TO_UNWIND_COLUMN (index);
   gcc_assert (index < (int) sizeof(dwarf_reg_size_table));
-  gcc_assert (dwarf_reg_size_table[index] == sizeof (_Unwind_Context_Reg_Val));
+  /* Return column size may be smaller than _Unwind_Context_Reg_Val.  */
+  gcc_assert (dwarf_reg_size_table[index] <= sizeof (_Unwind_Context_Reg_Val));
 
   context->by_value[index] = 1;
   context->reg[index] = _Unwind_Get_Unwind_Context_Reg_Val (val);
diff -rupN gcc-4.7-20120605/libgfortran/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libgfortran/ChangeLog.x32
--- gcc-4.7-20120605/libgfortran/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libgfortran/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libgo/config.h.in gcc-4.7-20120605-hjl-x32/libgo/config.h.in
--- gcc-4.7-20120605/libgo/config.h.in	2012-04-27 18:38:31.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/libgo/config.h.in	2012-06-05 15:38:08.000000000 +0200
@@ -286,6 +286,9 @@
 /* Define to 1 if you have the `wait4' function. */
 #undef HAVE_WAIT4
 
+/* Define to 1 if you have the `_dl_get_tls_static_info' function. */
+#undef HAVE__DL_GET_TLS_STATIC_INFO
+
 /* Define if the C++ compiler is configured for setjmp/longjmp exceptions. */
 #undef LIBGO_SJLJ_EXCEPTIONS
 
diff -rupN gcc-4.7-20120605/libgo/configure.ac gcc-4.7-20120605-hjl-x32/libgo/configure.ac
--- gcc-4.7-20120605/libgo/configure.ac	2012-04-27 18:38:31.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/libgo/configure.ac	2012-06-05 15:38:08.000000000 +0200
@@ -481,7 +481,7 @@ fi
 
 AM_CONDITIONAL(HAVE_SYS_MMAN_H, test "$ac_cv_header_sys_mman_h" = yes)
 
-AC_CHECK_FUNCS(strerror_r strsignal wait4 mincore setenv)
+AC_CHECK_FUNCS(strerror_r strsignal wait4 mincore setenv _dl_get_tls_static_info)
 AM_CONDITIONAL(HAVE_STRERROR_R, test "$ac_cv_func_strerror_r" = yes)
 AM_CONDITIONAL(HAVE_WAIT4, test "$ac_cv_func_wait4" = yes)
 
diff -rupN gcc-4.7-20120605/libgo/mksysinfo.sh gcc-4.7-20120605-hjl-x32/libgo/mksysinfo.sh
--- gcc-4.7-20120605/libgo/mksysinfo.sh	2012-04-30 18:04:33.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/libgo/mksysinfo.sh	2012-06-05 15:38:08.000000000 +0200
@@ -524,6 +524,8 @@ rusage=`grep '^type _rusage struct' gen-
 if test "$rusage" != ""; then
   rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
   rusage=`echo $rusage | sed -e 's/^ *//'`
+  # Remove anonymous unions from GNU/Linux <bits/resource.h>.
+  rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
   nrusage=
   while test -n "$rusage"; do
     field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
diff -rupN gcc-4.7-20120605/libgo/runtime/proc.c gcc-4.7-20120605-hjl-x32/libgo/runtime/proc.c
--- gcc-4.7-20120605/libgo/runtime/proc.c	2012-05-24 23:07:30.000000000 +0200
+++ gcc-4.7-20120605-hjl-x32/libgo/runtime/proc.c	2012-06-05 15:38:08.000000000 +0200
@@ -1105,6 +1105,7 @@ runtime_newm(void)
 	M *m;
 	pthread_attr_t attr;
 	pthread_t tid;
+	size_t stacksize;
 
 	m = runtime_malloc(sizeof(M));
 	mcommoninit(m);
@@ -1118,7 +1119,33 @@ runtime_newm(void)
 #ifndef PTHREAD_STACK_MIN
 #define PTHREAD_STACK_MIN 8192
 #endif
-	if(pthread_attr_setstacksize(&attr, PTHREAD_STACK_MIN) != 0)
+
+	stacksize = PTHREAD_STACK_MIN;
+
+#if 0
+#ifdef HAVE__DL_GET_TLS_STATIC_INFO
+	{
+		/* On GNU/Linux the static TLS size is taken out of
+		   the stack size, and we get an error or a crash if
+		   there is not enough stack space left.  Add it back
+		   in if we can, in case the program uses a lot of TLS
+		   space.  */
+#ifndef internal_function
+#ifdef __i386__
+#define internal_function __attribute__ ((regparm (3), stdcall))
+#else
+#define internal_function
+#endif
+#endif
+		extern void _dl_get_tls_static_info(size_t*, size_t*) internal_function;
+		size_t tlssize, tlsalign;
+		_dl_get_tls_static_info(&tlssize, &tlsalign);
+		stacksize += tlssize;
+	}
+#endif
+#endif
+
+	if(pthread_attr_setstacksize(&attr, stacksize) != 0)
 		runtime_throw("pthread_attr_setstacksize");
 
 	if(pthread_create(&tid, &attr, runtime_mstart, m) != 0)
diff -rupN gcc-4.7-20120605/libgomp/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libgomp/ChangeLog.x32
--- gcc-4.7-20120605/libgomp/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libgomp/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,8 @@
+2012-03-31  H.J. Lu  <hongjiu.lu@intel.com>
+
+	PR bootstrap/52812
+	* configure.tgt (i[456]86-*-linux*): Handle -mx32 like -m64.
+
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libgomp/configure.tgt gcc-4.7-20120605-hjl-x32/libgomp/configure.tgt
--- gcc-4.7-20120605/libgomp/configure.tgt	2012-02-14 11:02:21.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libgomp/configure.tgt	2012-06-05 15:38:08.000000000 +0200
@@ -59,7 +59,7 @@ if test $enable_linux_futex = yes; then
     i[456]86-*-linux*)
 	config_path="linux/x86 linux posix"
 	case " ${CC} ${CFLAGS} " in
-	  *" -m64 "*)
+	  *" -m64 "*|*" -mx32 "*)
 	    ;;
 	  *)
 	    if test -z "$with_arch"; then
diff -rupN gcc-4.7-20120605/libitm/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libitm/ChangeLog.x32
--- gcc-4.7-20120605/libitm/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libitm/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,8 @@
+2012-03-31  H.J. Lu  <hongjiu.lu@intel.com>
+
+	PR bootstrap/52812
+	* configure.tgt (i[456]86-*-linux*): Handle -mx32 like -m64.
+
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libitm/configure.tgt gcc-4.7-20120605-hjl-x32/libitm/configure.tgt
--- gcc-4.7-20120605/libitm/configure.tgt	2012-02-13 22:51:44.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libitm/configure.tgt	2012-06-05 15:38:08.000000000 +0200
@@ -53,7 +53,7 @@ case "${target_cpu}" in
 
   i[3456]86)
 	case " ${CC} ${CFLAGS} " in
-	  *" -m64 "*)
+	  *" -m64 "*|*" -mx32 "*)
 	    ;;
 	  *)
 	    if test -z "$with_arch"; then
diff -rupN gcc-4.7-20120605/libjava/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libjava/ChangeLog.x32
--- gcc-4.7-20120605/libjava/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libjava/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libjava/classpath/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libjava/classpath/ChangeLog.x32
--- gcc-4.7-20120605/libjava/classpath/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libjava/classpath/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libmudflap/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libmudflap/ChangeLog.x32
--- gcc-4.7-20120605/libmudflap/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libmudflap/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libobjc/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libobjc/ChangeLog.x32
--- gcc-4.7-20120605/libobjc/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libobjc/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libquadmath/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libquadmath/ChangeLog.x32
--- gcc-4.7-20120605/libquadmath/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libquadmath/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libssp/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libssp/ChangeLog.x32
--- gcc-4.7-20120605/libssp/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libssp/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libstdc++-v3/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/libstdc++-v3/ChangeLog.x32
--- gcc-4.7-20120605/libstdc++-v3/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libstdc++-v3/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/libtool.m4 gcc-4.7-20120605-hjl-x32/libtool.m4
--- gcc-4.7-20120605/libtool.m4	2011-11-21 20:22:35.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/libtool.m4	2012-06-05 15:38:08.000000000 +0200
@@ -1232,7 +1232,14 @@ s390*-*linux*|s390*-*tpf*|sparc*-*linux*
 	    LD="${LD-ld} -m elf_i386_fbsd"
 	    ;;
 	  x86_64-*linux*)
-	    LD="${LD-ld} -m elf_i386"
+	    case `/usr/bin/file conftest.o` in
+	      *x86-64*)
+		LD="${LD-ld} -m elf32_x86_64"
+		;;
+	      *)
+		LD="${LD-ld} -m elf_i386"
+		;;
+	    esac
 	    ;;
 	  ppc64-*linux*|powerpc64-*linux*)
 	    LD="${LD-ld} -m elf32ppclinux"
diff -rupN gcc-4.7-20120605/lto-plugin/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/lto-plugin/ChangeLog.x32
--- gcc-4.7-20120605/lto-plugin/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/lto-plugin/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
diff -rupN gcc-4.7-20120605/zlib/ChangeLog.x32 gcc-4.7-20120605-hjl-x32/zlib/ChangeLog.x32
--- gcc-4.7-20120605/zlib/ChangeLog.x32	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.7-20120605-hjl-x32/zlib/ChangeLog.x32	2012-06-05 15:38:08.000000000 +0200
@@ -0,0 +1,3 @@
+2012-05-16  H.J. Lu  <hongjiu.lu@intel.com>
+
+	* configure: Regenerated.
